/**
 * Module Dependencies
 */

var generator = require('is-generator-fn')
var Context = require('./context')
var co = require('co')

/**
 * Export `Compose`
 */

module.exports = compose

/**
 * Compose
 */

function compose (mw) {
  return function (action, ctx) {
    let index = -1

    function dispatch (p) {
      if (p <= index) throw new TypeError('`next()` called multiple times')

      index = p

      var ctx, fn
      if (mw[p]) {
        ctx = new Context(mw[p].state)
        fn = generator(mw[p].fn)
          ? co.wrap(mw[p].fn)
          : mw[p].fn
      } else {
        fn = ident
        ctx = new Context()
      }

      return new Promise(resolve => {
        return resolve(fn(action, function next () {
          return dispatch(p + 1)
        }, ctx))
      })
    }

    return dispatch(0)
  }
}

/**
 * Identity
 */

function ident (i) {
  return i
}
